<?php

/**
 * Blackbird MenuManager Module
 *
 * NOTICE OF LICENSE
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to contact@bird.eu so we can send you a copy immediately.
 *
 * @category            Blackbird
 * @package		Blackbird_MenuManager
 * @copyright           Copyright (c) 2016 Blackbird (http://black.bird.eu)
 * @author		Blackbird Team
 */

namespace FiloBlu\ExtBlackbirdMenuManager\Model;

use Blackbird\MenuManager\Model\ResourceModel\Menu\CollectionFactory;
use Magento\Framework\Api\SearchResultsInterfaceFactory;

class MenuRepository extends \Blackbird\MenuManager\Model\MenuRepository {

    protected $_httpContext;
    protected $_customerSession;

    public function __construct(
    \Blackbird\MenuManager\Model\MenuFactory $objectFactory, CollectionFactory $collectionFactory, SearchResultsInterfaceFactory $searchResultsFactory, \Blackbird\MenuManager\Model\ResourceModel\Menu $menuResourceModel, \Magento\Framework\App\Http\Context $httpContext, \Magento\Customer\Model\Session $customerSession
    ) {
        parent::__construct($objectFactory, $collectionFactory, $searchResultsFactory, $objectFactory, $menuResourceModel);
        $this->_httpContext = $httpContext;
        $this->_customerSession = $customerSession;
    }

    public function get($identifier, $storeId) {
        $_currentCustomerGroupId = "-1";
        if ($this->_httpContext->getValue(\Magento\Customer\Model\Context::CONTEXT_AUTH)) {
            $_currentCustomerGroupId = "-2,";
            $_currentCustomerGroupId = $_currentCustomerGroupId . $this->_customerSession->getCustomer()->getGroupId();
        }

        $collection = $this->collectionFactory->create();
        $collection->addFilter('identifier', $identifier);
        $collection->addFilter('is_active', 1);
        $collection->addFieldToFilter(['customer_group', 'customer_group'], [
            ['in' => $_currentCustomerGroupId],
            array('null' => true)
        ]);
        $collection->join(['stores' => 'blackbird_menumanager_store'], 'main_table.menu_id = stores.menu_id', 'store_id');
        $collection->addFieldToFilter(['store_id', 'store_id'], [['eq' => $storeId], ['eq' => self::ID_ALL_STORE_VIEW]]);
        $collection->setOrder('store_id', 'DESC');

        return $collection->getFirstItem();
    }

}
